/*
**************************************************************************
This is a modified script.(Information on an original script is the following)
Very thanks to steve johnson!!

Usage:
- Put into "ui\macroscripts" folder, then add Menus or Quads.

2009.12.06
by ponz
http://ponz2009.web.fc2.com

**************************************************************************

					skintools V1.33 by steve johnson						
	includes:-
		save vertex weights
		save selected vertex weights
		replace vertex weights index mode
		replace vertex weights position mode
		mirror bones
		get skin element
		reverse cross section
		clear zero weights
		skin weight info
		re-grab skin
		skin gradient
	
	or
	
	visit www.chuggnut.com
	
**************************************************************************
*/

macroscript skintools_about category:"Skin Tools" buttontext:"About Skin Tools"
	(
	on isvisible do
		(
		return (classof (modpanel.getcurrentobject()) == skin)
		)
	
	on execute do
		(
		messagebox "Skin Tools\nV1.33\nBy Steve Johnson\nwww.chuggnut.com\n\nfixed for gmax by ponz 09.07.18" title:"Skin Tools"
		)
	)

--***********************************************************************************************************************************************************************************	

macroscript replaceposition category:"Skin Tools" buttontext:"Replace Weights Position Mode"
	(
	local prog

	on isvisible do
		(
		return (classof (modpanel.getcurrentobject()) == skin)
		)
	
	on execute do
		(
		escapeenable = false
		rollout prog "Matching..."
			(
			progressbar goodbar color:(color 0 255 0) height:7 width:170 align:#left offset:[-2,-1]
			progressbar badbar color:(color 255 0 0) height:7 width:170 align:#left offset:[-2,-4]
			spinner threshhold "Theshhold" range:[0.00001,10.0,0.001] type:#float pos:[190,2] fieldwidth:60
			button domatch "GO!" height:15 width:25 pos:[320,2]
			
			on domatch pressed do
				(
				inname = getopenfilename caption:"Open weights" filename:"*.gwt;*.wts;*.xml" types:"Skin Weights (*.gwt)|*.gwt|Skin Weights (*.wts)|*.wts|Skin Weights (*.xml)|*.xml"
				if inname != undefined then
					(
					setwaitcursor()
					v = #()
					struct vertexweight (pos, id, weight)
					file_ext = getFilenameType(inname)
					if(".gwt" == file_ext) then
						(
						infile = fopen inname "rb"
						gwt_head = ReadLong infile
						if gwt_head == 0x53545753 then  -- GWT_HEADER:"SWTS" = '0x53545753'
							(
							num_verts = ReadLong infile
							for i = 1 to num_verts do
								(
								v[i] = vertexweight pos:[0,0,0] id:#() weight:#()
								vert = readlong infile
								x = readfloat infile
								y = readfloat infile
								z = readfloat infile
								bones = readlong infile
								for n = 1 to bones do
									(
									v[i].id[n] = (readlong infile)
									v[i].weight[n] = (readfloat infile)
									)  --for(n)
								v[i].pos = [x,y,z]
								)  --for(i)
							fclose infile
							)  --if(gwt_head)
						else
							(
							fclose infile
							escapeenable = true
							messagebox "Not right file type!"
							destroydialog prog
							)  --if(gwt_head)
						)  --if(gwt)
					else
						(
						infile = openfile inname
						if (readline infile) == "[WEIGHTS]" then
							(
							for i = 1 to ((readline infile) as integer) do
								(
								v[i] = vertexweight pos:[0,0,0] id:#() weight:#()
								vert = readvalue infile
								x = (readvalue infile) as float
								y = (readvalue infile) as float
								z = (readvalue infile) as float
								bones = readvalue infile
								for n = 1 to (bones as integer) do
									(
									v[i].id[n] = (readvalue infile)
									v[i].weight[n] = (readvalue infile)
									)  --for(n)
								v[i].pos = [x,y ,z]
								)  --for(i)
							close infile
							)  --if(readline)
						else
							(
							close infile
							escapeenable = true
							messagebox "Not right file type!"
							destroydialog prog
							) --if(readline)
						)  --else(gwt)
				
					if v != undefined do
						(
						skinobject = modpanel.getcurrentobject()
						omesh = $.mesh
						disablesceneredraw()
						try
							(
							if false then --loop skip
								(
								good = 0
								bad = 0
								badv = #{}
								objverts = (omesh.verts as bitarray) as array

								for i = 1 to v.count do
									(
									vindex = 0

									for c = 1 to objverts.count do
										(
										vp = (getvert omesh objverts[c]) 
										if (length (vp - v[i].pos)) < threshhold.value do
											(
											vindex = c
											exit
											)
										)
						
									if vindex != 0 then
										(
										skinops.replacevertexweights skinobject objverts[vindex] v[i].id v[i].weight
										good += 1
										goodbar.value = (good as float / v.count) * 100
										)
									else
										(
										bad += 1
										badbar.value = (bad as float / v.count) * 100
										)
									)
								badv = objverts
								)
							else --loop through verts and match to data
								(
								good = 0
								bad = 0
								badv = #{}
								for i = 1 to omesh.numverts do
									(
									vindex = 0
									vp = (getvert omesh i)
									for c = 1 to v.count do
										(
										if (length (vp - v[c].pos)) < threshhold.value do
											(
											vindex = c
											exit
											)
										)
						
									if vindex != 0 then
										(
										skinops.replacevertexweights skinobject i v[vindex].id v[vindex].weight
										good += 1
										goodbar.value = (good as float / omesh.numverts) * 100
										)
									else
										(
										bad += 1
										badbar.value = (bad as float / omesh.numverts) * 100
										badv[i] = true
										)
									)
								)
							if bad != 0 do
								(
								skinops.selectvertices skinobject badv
								)
							pushprompt ("Replaced " + good as string + " vertex weights, failed on " + bad as string + " vertices")
							enablesceneredraw()
							escapeenable = true
							destroydialog prog
							)
						catch
							(
							enablesceneredraw()
							messagebox "Error!"
							escapeenable = true
							omesh = undefined
							gc()
							setarrowcursor()							
							destroydialog prog
							)
						)
					)
				else
					(
					escapeenable = true
					setarrowcursor()
					omesh = undefined
					gc()					
					destroydialog prog					
					)
				)
			
			)--end of rollout
		createdialog prog 350 25 
		)-- end of on execute
	)--end of macro
	
--***********************************************************************************************************************************************************************************	

macroscript replaceindex category:"Skin Tools" buttontext:"Replace Weights Index Mode"
	(
	local prog

	on isvisible do
		(
		return (classof (modpanel.getcurrentobject()) == skin)
		)
	
	on execute do
		(
		escapeenable = false
		rollout prog "Matching..."
			(
			progressbar pbar width:190 align:#center offset:[1,0]
			timer thetime active:false interval:10
			
			on thetime tick do
				(
				thetime.active = false
				inname = getopenfilename caption:"Open weights" filename:"*.gwt;*.wts;*.xml" types:"Skin Weights (*.gwt)|*.gwt|Skin Weights (*.wts)|*.wts|Skin Weights (*.xml)|*.xml"
				if inname != undefined then
					(
					v = #()
					struct vertexweight (pos, id, weight)
					file_ext = getFilenameType(inname)
					if(".gwt" == file_ext) then
						(
						infile = fopen inname "rb"
						gwt_head = ReadLong infile
						if gwt_head == 0x53545753 then  -- GWT_HEADER:"SWTS" = '0x53545753'
							(
							num_verts = ReadLong infile
							for i = 1 to num_verts do
								(
								v[i] = vertexweight pos:[0,0,0] id:#() weight:#()
								vert = readlong infile
								x = readfloat infile
								y = readfloat infile
								z = readfloat infile
								bones = readlong infile
								for n = 1 to bones do
									(
									v[i].id[n] = (readlong infile)
									v[i].weight[n] = (readfloat infile)
									)  --for(n)
								v[i].pos = [x,y,z]
								)  --for(i)
							fclose infile
							)  --if(gwt_head)
						else
							(
							fclose infile
							escapeenable = true
							messagebox "Not right file type!"
							destroydialog prog
							)  --if(gwt_head)
						)  --if(gwt)
					else
						(
						infile = openfile inname
						if (readline infile) == "[WEIGHTS]" then
							(
							for i = 1 to ((readline infile) as integer) do
								(
								v[i] = vertexweight pos:[0,0,0] id:#() weight:#()
								vert = readvalue infile
								x = (readvalue infile) as float
								y = (readvalue infile) as float
								z = (readvalue infile) as float
								bones = readvalue infile
								for n = 1 to (bones as integer) do
									(
									v[i].id[n] = (readvalue infile)
									v[i].weight[n] = (readvalue infile)
									)  --for(n)
								v[i].pos = [x,y ,z]
								)  --for(i)
							close infile
							)  --if(readline)
						else
							(
							close infile
							escapeenable = true
							messagebox "Not right file type!"
							destroydialog prog
							) --if(readline)
						)  --else(gwt)
				
					if v != undefined do
						(
						skinobject = modpanel.getcurrentobject()
						omesh = $.mesh
			
						count = 0
						if v.count < omesh.numverts then
							(
							count = v.count
							)
						else
							(
							count = omesh.numverts
							)
						disablesceneredraw()
						try
							(
							for i = 1 to count do
								(
								skinops.replacevertexweights skinobject i v[i].id v[i].weight
								pbar.value = (i as float / count) * 100
								)
							
							pushprompt ("Replaced " + count as string + " vertex weights")
							enablesceneredraw()
							escapeenable = true
							omesh = undefined
							gc()
							destroydialog prog
							)
						catch
							(
							enablesceneredraw()
							messagebox "Error!"
							escapeenable = true
							omesh = undefined
							gc()
							destroydialog prog
							)
						)
					)
				else
					(
					escapeenable = true
					destroydialog prog
					)
				)
			
			on prog open do
				(
				thetime.active = true
				)--end of on open
			)--end of rollout
		createdialog prog 200 25 --style:#(#style_sunkenedge)
		)-- end of on execute
	)--end of macro

--***********************************************************************************************************************************************************************************

macroscript saveweights category:"Skin Tools" buttontext:"Save Vertex Weights"
	(
	on isvisible do
		(
		return (classof (modpanel.getcurrentobject()) == skin)
		)	
	
	on execute do
		(
		if (outname = getsavefilename caption:"Save weights" filename:"*.wts" types:"Skin Weights (*.wts)|*.wts") != undefined do
			(
			skinobject = modpanel.getcurrentobject()
			omesh = $.mesh
			out = createfile outname
			format "[WEIGHTS]\n" to:out
			format "%\n" omesh.numverts to:out
			--invtm = inverse $.transform

			for i = 1 to omesh.numverts do
				(
				v = getvert omesh i
				format "%, %, %, %, %, " i v.x v.y v.z (skinops.getvertexweightcount skinobject i) to:out
				for n = 1 to (skinops.getvertexweightcount skinobject i) do
					(
					id = (skinops.getvertexweightboneid skinobject i n) 
					weight = (skinops.getvertexweight skinobject i n)
					format "%, % " id ((weight * 1000)as integer / 1000.0) to:out
					)
				format "\n" to:out
				)
			format "[END]" to:out
			close out
			omesh = undefined
			gc()
			messagebox "Weights Saved!" title:"Foghorn Leghorn"
			)
		)
	)

--***********************************************************************************************************************************************************************************

macroscript saveselectedweights category:"Skin Tools" buttontext:"Save Selected Vertex Weights"
	(
	on isvisible do
		(
		return (classof (modpanel.getcurrentobject()) == skin)
		)	
	
	on execute do
		(
		if (outname = getsavefilename caption:"Save weights" filename:"*.wts" types:"Skin Weights (*.wts)|*.wts") != undefined do
			(
			skinobject = modpanel.getcurrentobject()
			out = createfile outname
			format "[WEIGHTS]\n" to:out
			vw = #()
			vwcount = 0
			omesh = $.mesh
			
			for i = 1 to omesh.numverts do
				(
				if (skinops.isvertexselected skinobject i == 1) do
					(
					vw[vwcount += 1] = i
					)
				)
			format "%\n" vwcount to:out
			invtm = $.transform
			invtm = inverse invtm
			
			for i = 1 to vwcount do
				(
				v = (getvert omesh vw[i])
				format "%, %, %, %, %, " vw[i] v.x v.y v.z (skinops.getvertexweightcount skinobject vw[i]) to:out
				for n = 1 to (skinops.getvertexweightcount skinobject vw[i]) do
					(
					id = (skinops.getvertexweightboneid skinobject vw[i] n) 
					weight = (skinops.getvertexweight skinobject vw[i] n)
					format "%, % " id ((weight * 1000)as integer / 1000.0) to:out
					)
				format "\n" to:out
				)
			format "[END]" to:out
			close out
			omesh = undefined
			gc()
			messagebox "Weights Saved!" title:"Foghorn Leghorn"
			)
		)
	)

--***********************************************************************************************************************************************************************************

macroscript saveweights_gmax category:"Skin Tools" buttontext:"Save Vertex Weights for Gmax"
	(
	on isvisible do
		(
		return (classof (modpanel.getcurrentobject()) == skin)
		)	
	
	on execute do
		(
		outname = getsavefilename caption:"Save weights" filename:"*.gwt" types:"Skin Weights (*.gwt)|*.gwt"
		if outname != undefined do
			(
			skinobject = modpanel.getcurrentobject()
			omesh = $.mesh
			format "\n"             --Don't remove this, it solve some win98 user problem
			clearlistener()
			format "<snoopstart file=%>\n" outname
			format "c 4 SWTS i 1 %\n" omesh.numverts
			for i = 1 to omesh.numverts do
				(
				v = getvert omesh i
--				format "%, %, %, %, %, " i v.x v.y v.z (skinops.getvertexweightcount skinobject i)
				format "i 1 % f 3 % % % i 1 %\n" i v.x v.y v.z (skinops.getvertexweightcount skinobject i)
				for n = 1 to (skinops.getvertexweightcount skinobject i) do
					(
					id = (skinops.getvertexweightboneid skinobject i n) 
					weight = (skinops.getvertexweight skinobject i n)
--					format "  %, % " id ((weight * 1000)as integer / 1000.0)
					format "i 1 % f 1 % " id ((weight * 1000)as integer / 1000.0)
					)  --for(n)
				if 0 != (skinops.getvertexweightcount skinobject i) do format "\n"
				)
--			format "[END]\n"
			format "</snoopend>\n"
			format "//"             --Don't remove this, it solve some win98 user problem
			omesh = undefined
			gc()
--			messagebox ("Weights Dumped! GRAB from Listener.") title:"Foghorn Leghorn"
			messagebox ("Weights Saved!") title:"Foghorn Leghorn"
			)
		)
	)

--***********************************************************************************************************************************************************************************

macroscript saveselectedweights_gmax category:"Skin Tools" buttontext:"Save Selected Vertex Weights for Gmax"
	(
	on isvisible do
		(
		return (classof (modpanel.getcurrentobject()) == skin)
		)	
	
	on execute do
		(
		outname = getsavefilename caption:"Save weights" filename:"*.gwt" types:"Skin Weights (*.gwt)|*.gwt"
		if outname != undefined do
			(
			skinobject = modpanel.getcurrentobject()
			vw = #()
			vwcount = 0
			omesh = $.mesh
			
			for i = 1 to omesh.numverts do
				(
				if (skinops.isvertexselected skinobject i == 1) do
					(
					vw[vwcount += 1] = i
					)
				)
--			format "%\n" vwcount

			format "\n"             --Don't remove this, it solve some win98 user problem
			clearlistener()
			format "<snoopstart file=%>\n" outname
			format "c 4\nSWTS i 1 %\n" vwcount
			invtm = $.transform
			invtm = inverse invtm
			
			for i = 1 to vwcount do
				(
				v = (getvert omesh vw[i])
--				format "%, %, %, %, %, " vw[i] v.x v.y v.z (skinops.getvertexweightcount skinobject vw[i])
				format "i 1 % f 3 % % % i 1 %\n" vw[i] v.x v.y v.z (skinops.getvertexweightcount skinobject vw[i])
				for n = 1 to (skinops.getvertexweightcount skinobject vw[i]) do
					(
					id = (skinops.getvertexweightboneid skinobject vw[i] n) 
					weight = (skinops.getvertexweight skinobject vw[i] n)
--					format "  %, % " id ((weight * 1000)as integer / 1000.0)
					format "i 1 % f 1 % " id ((weight * 1000)as integer / 1000.0)
					)
--				format "\n"
				if 0 != (skinops.getvertexweightcount skinobject vw[i]) do format "\n"
				)
--			format "[END]\n"
			format "</snoopend>\n"
			format "//"             --Don't remove this, it solve some win98 user problem
			omesh = undefined
			gc()
--			messagebox ("Weights Dumped! GRAB from Listener.") title:"Foghorn Leghorn"
			messagebox ("Weights Saved!") title:"Foghorn Leghorn"
			)
		)
	)

--***********************************************************************************************************************************************************************************

macroscript saveweights_gmax_text category:"Skin Tools" buttontext:"Save Vertex Weights for Gmax (as text file)"
	(
	on isvisible do
		(
		return (classof (modpanel.getcurrentobject()) == skin)
		)	
	
	on execute do
		(
--		if (outname = getsavefilename caption:"Save weights" filename:"*.wts" types:"Skin Weights (*.wts)|*.wts") != undefined do
			(
			skinobject = modpanel.getcurrentobject()
			omesh = $.mesh
			format "\n"             --Don't remove this, it solve some win98 user problem
			clearlistener()
			format "[WEIGHTS]\n"
			format "%\n" omesh.numverts
			--invtm = inverse $.transform

			for i = 1 to omesh.numverts do
				(
				v = getvert omesh i
				format "%, %, %, %, %, " i v.x v.y v.z (skinops.getvertexweightcount skinobject i)
				for n = 1 to (skinops.getvertexweightcount skinobject i) do
					(
					id = (skinops.getvertexweightboneid skinobject i n) 
					weight = (skinops.getvertexweight skinobject i n)
					format "  %, % " id ((weight * 1000)as integer / 1000.0)
					)
				format "\n"
				)
			format "[END]\n"
			format "//"             --Don't remove this, it solve some win98 user problem
			omesh = undefined
			gc()
			messagebox ("Weights Dumped! then GRAB from Listener.") title:"Foghorn Leghorn"
			)
		)
	)

--***********************************************************************************************************************************************************************************

macroscript saveselectedweights_gmax_text category:"Skin Tools" buttontext:"Save Selected Vertex Weights for Gmax (as text file)"
	(
	on isvisible do
		(
		return (classof (modpanel.getcurrentobject()) == skin)
		)	
	
	on execute do
		(
--		if (outname = getsavefilename caption:"Save weights" filename:"*.wts" types:"Skin Weights (*.wts)|*.wts") != undefined do
			(
			skinobject = modpanel.getcurrentobject()
			format "\n"             --Don't remove this, it solve some win98 user problem
			clearlistener()
			format "[WEIGHTS]\n"
			vw = #()
			vwcount = 0
			omesh = $.mesh
			
			for i = 1 to omesh.numverts do
				(
				if (skinops.isvertexselected skinobject i == 1) do
					(
					vw[vwcount += 1] = i
					)
				)
			format "%\n" vwcount
			invtm = $.transform
			invtm = inverse invtm
			
			for i = 1 to vwcount do
				(
				v = (getvert omesh vw[i])
				format "%, %, %, %, %, " vw[i] v.x v.y v.z (skinops.getvertexweightcount skinobject vw[i])
				for n = 1 to (skinops.getvertexweightcount skinobject vw[i]) do
					(
					id = (skinops.getvertexweightboneid skinobject vw[i] n) 
					weight = (skinops.getvertexweight skinobject vw[i] n)
					format "  %, % " id ((weight * 1000)as integer / 1000.0)
					)
				format "\n"
				)
			format "[END]\n"
			format "//"             --Don't remove this, it solve some win98 user problem
			omesh = undefined
			gc()
			messagebox ("Weights Dumped! then GRAB from Listener.") title:"Foghorn Leghorn"
			)
		)
	)

--***********************************************************************************************************************************************************************************

macroscript getskinelement category:"Skin Tools" buttontext:"Get Skin Element"
	(
	on isvisible do
		(
		return ((selection.count == 1) and (classof (modpanel.getcurrentobject()) == skin))
		)
	
	on execute do
		(
		if classof $ == editable_mesh do
			(
			function mtrack msg ir obj facenum shift crtl alt args = 
				(
				function getselectedskinverts skn = 
					(
					vsel = #{}
					for i = 1 to skinops.getnumbervertices skn do
						(
						if (skinops.isvertexselected skn i) == 1 do	vsel[i] = true
						)
					return vsel
					)
					
				case msg of
					(
					#mousepoint : 	(
					print facenum
									fsel = meshop.getelementsusingface $ facenum
									
									if alt do -- take away
										(
										skinops.selectvertices args[1] ((getselectedskinverts args[1]) - (meshop.getvertsusingface $ fsel))
										return false
										)
	
									if crtl do -- add to
										(
										skinops.selectvertices args[1] ((getselectedskinverts args[1]) + (meshop.getvertsusingface $ fsel))
										return false
										)									
										
									skinops.selectvertices args[1] (meshop.getvertsusingface $ fsel)
									return false
									)
					#mouseabort : (return false)
					)
				#continue
				)
	
			skinobj = modpanel.getcurrentobject()
			selbone = skinops.getselectedbone skinobj
			mousetrack on:selection[1] trackcallback:#(mtrack, #(skinobj, selbone))
			)

		if classof $ == polymeshobject do
			(
			skinobj = modpanel.getcurrentobject()

			selverts = #()
				for i = 1 to skinops.getnumbervertices skinobj do
					(
					if (skinops.isvertexselected skinobj i) == 1 do	append selverts i
					)
			
			if selverts.count != 0 do
				(
				f = (polyop.getfacesusingvert $ selverts[1])
				fsel = polyop.getelementsusingface $ f
				skinops.selectvertices skinobj (polyop.getvertsusingface $ fsel)
				)
			)
		)
	)-- end of macro

--***********************************************************************************************************************************************************************************

macroscript clearzeroweights category:"Skin Tools" buttontext:"Clear Zero Weights"
	(
	on isvisible do
		(
		return ((selection.count == 1) and (classof (modpanel.getcurrentobject()) == skin))
		)
	
	on execute do
		(
		disablesceneredraw()
		try
			(
			sknobj = modpanel.getcurrentobject()
			clearcount = 0
			for i = 1 to $.numverts do
				(
				bones = skinops.getvertexweightcount sknobj i
				id = #()
				weight = #()
				idcount = 0
				norm = 0
				for n = 1 to bones do
					(
					if (w = skinops.getvertexweight sknobj i n) > 0.0001 do
						(
						boneindex = skinops.getvertexweightboneid sknobj i n
						id[idcount += 1] = boneindex
						weight[idcount] = w
						norm += w
						)
					)
				
				for n = 1 to idcount do
					(
					weight[n] /= norm
					)
				clearcount += (bones - idcount)
				
				skinops.replacevertexweights sknobj i id weight
				)
			enablesceneredraw()
			pushprompt ("Cleared " + clearcount as string + " zero weights.")
			)
		catch
			(
			enablesceneredraw()
			pushprompt ("Error in clearing zero weights.")
			)
		)
	)

--***********************************************************************************************************************************************************************************

macroscript paintabsoluteweight category:"Skin Tools" buttontext:"Paint absolute weight"
	(
	local skinpaintroll
	on isvisible do
		(
		return (classof (modpanel.getcurrentobject()) == skin)
		)
	
	on execute do
		(
		rollout skinpaintroll "Options" width:120 height:95
			(
			spinner weight "Weight" width:97 height:16 range:[0,1,0] scale:0.01 align:#center fieldwidth:40
			spinner tol "Size" width:97 height:16 range:[0.0,10.0,1] scale:0.01 align:#center fieldwidth:40
			button dopaint "Paint" width:100 height:23 align:#center


			on dopaint pressed do
				(
				function mtrack msg ir obj facenum shift crtl alt args = 
					(
					case msg of
						(
						#freemove : 	(
										if ir != undefined do
											(
											args[5].pos = ir.pos
											args[5].dir = ir.dir
											)
										)
						#mousemove : 	(
										if ir != undefined do
											(
											args[5].pos = ir.pos
											args[5].dir = ir.dir
											f = getface args[6] facenum
											v1 = (getvert args[6] f.x) * obj.objecttransform
											v2 = (getvert args[6] f.y) * obj.objecttransform
											v3 = (getvert args[6] f.z) * obj.objecttransform
											
											if (length (v1 - ir.pos)) <= args[4] do
												(
												skinops.setvertexweights args[1] f.x args[2] args[3]
												)
											if (length (v2 - ir.pos)) <= args[4] do
												(
												skinops.setvertexweights args[1] f.y args[2] args[3]
												)
											if (length (v3 - ir.pos)) <= args[4] do
												(
												skinops.setvertexweights args[1] f.z args[2] args[3]
												)										
											)
										return #continue
										)
						#mouseabort : (flagforeground $ false ; flagforeground args[5] false; delete args[5]; return false)
						)
					return #continue
					)
				
				flagforeground $ true
				skinobj = modpanel.getcurrentobject()
				selbone = skinops.getselectedbone skinobj
				marker = circle radius:(tol.value) wirecolor:(yellow)
				flagforeground marker true
				mousetrack on:$ trackcallback:#(mtrack, #(skinobj, selbone, weight.value, tol.value, marker, $.mesh))
				)
			)
		
		createdialog skinpaintroll 120 75
		)
	)-- end of macro

--***********************************************************************************************************************************************************************************

macroScript mirrorbonepaste category:"Skin Tools" buttontext:"Mirror Bone Paste"
	(
	local mirrorpaste
	on isvisible do
		(
		return (classof (modpanel.getcurrentobject()) == skin)
		)
	
	on execute do
		(
		rollout Mirrorpaste "Mirror Paste" width:130 height:270
			(
			local weights, bones, failed, failedlist, showexpected = false
			local expected = #()			
			local omesh
			
			function getoppositebone tmpskinobj source lident rident = 
				(
				local findobj
				sourcename = skinops.getbonename tmpskinobj source 1
				if (matchpattern sourcename pattern:("*" + lident + "*") ignorecase:false) then
					(
					--print "flipping to right"
					f = findstring sourcename lident
					findobj = replace sourcename f lident.count rident 
					)
				else
					(
					if (matchpattern sourcename pattern:("*" + rident + "*") ignorecase:false) then
						(
						--print "flipping to left"
						f = findstring sourcename rident
						findobj = replace sourcename f rident.count lident 
						)
					else
						(
						--print "not flipping"
						return source
						)
					)
				for i = 1 to (skinops.getnumberbones tmpskinobj) do
					(
					if (skinops.getbonename tmpskinobj i 1) == findobj do
						(
						return i
						)
					)
				return source
				)			
			
			function findmirrorvert obj &omesh vert axis tol cpoint = 
				(
				num = 1
				
				case cpoint of
					(
					3 : c = [0,0,0]
					2 : c = obj.pivot
					1 : c = obj.center
					)
				
				testvert = ((getvert omesh vert) * obj.objecttransform) - c
				
				case axis of
					(
					#X : testvert *= [-1,1,1]
					#Y : testvert *= [1,-1,1]
					#Z : testvert *= [1,1,-1]
					#XY : testvert *= [-1,-1,1]
					#XZ : testvert *= [-1,1,-1]
					#YZ : testvert *= [1,-1,-1]
					)
					
				for i = 1 to omesh.numverts do
					(
					v = ((getvert omesh i) * obj.objecttransform) - c

					if (length (v - testvert)) < tol do
						(
						return i
						)
					)
				return (testvert + c)
				)
			
			function drawfailed = 
				(
				gw.settransform (matrix3 1)

				for i in mirrorpaste.expected do
					(
					gw.marker i #plussign color:yellow
					)
				gw.enlargeupdaterect #whole
				gw.updatescreen()				
				)
	
			groupBox grp1 "World Axis" pos:[5,4] width:120 height:54
			radioButtons useaxis "" pos:[9,22] width:111 height:32 labels:#("X", "Y", "Z", "XY", "XZ", "YZ") columns:3
			groupBox grp2 "Bone Identifiers" pos:[5,62] width:120 height:57
			editText leftident "" pos:[41,80] width:80 height:1 text:"L"
			editText rightident "" pos:[41,99] width:80 height:1 text:"R"
			groupBox grp3 "Mirror Centre" pos:[5,124] width:120 height:57
			radioButtons centrepoint "" pos:[12,142] width:102 height:32 labels:#("Mesh", "Pivot", "World") columns:2
			spinner threshhold "Threshhold" pos:[14,186] width:102 height:16 range:[0.000001,10,0.001] scale:0.01
			button Mirrorverts "Mirror" pos:[5,206] width:120 height:20
			progressBar pbar "" pos:[5,229] width:120 height:10 color:(color 30 10 190)
			checkButton viewcancel "Cancel Display" pos:[5,243] width:120 height:20 highlightcolor:green
			label lbl1 "Left" pos:[11,82] width:32 height:15
			label lbl2 "Right" pos:[11,98] width:32 height:15
			
			on mirrorpaste close do
				(
				if showexpected do
					(
					unregisterredrawviewscallback drawfailed
					completeredraw()					
					)
				)
			
			on mirrorverts pressed do
				(
				omesh = $.mesh
				if showexpected do
					(
					unregisterredrawviewscallback drawfailed
					viewcancel.checked = false
					viewcancel.enabled = false
					showexpected = false					
					completeredraw()					
					)				
				
				failed = 0
				failedlist = #{}
				expected = #()
				
				case useaxis.state of
					(
					1 : axis = #X
					2 : axis = #Y
					3 : axis = #Z
					4 : axis = #XY
					5 : axis = #XZ
					6 : axis = #YZ
					)
				
				skinobj = modpanel.getcurrentobject()
				
				selverts = #()
				selvertsnum = 0
				for i = 1 to omesh.numverts do
					(
					if (skinops.isvertexselected skinobj i) == 1 do selverts[selvertsnum += 1] = i
					)
				
				if selvertsnum != 0 then
					(
					ts_start = timeStamp()
					with redraw off
						(
						setwaitcursor()
						for i = 1 to selvertsnum do
							(
							if classof (newv = findmirrorvert $ &omesh selverts[i] axis threshhold.value centrepoint.state) == integer then
								(
								weights = #()
								bones = #()
								numbones = skinops.getvertexweightcount skinobj selverts[i]

								for n = 1 to numbones do
									(
									weights[n] = skinops.getvertexweight skinobj selverts[i] n
									boneid = (skinops.getvertexweightboneid skinobj selverts[i] n)
									bones[n] = getoppositebone skinobj boneid leftident.text rightident.text
									)
								
								skinops.replacevertexweights skinobj newv bones weights
								)
							else
								(
								failed += 1
								failedlist[selverts[i]] = true
								append expected newv
								)
							pbar.value = (i as float / selvertsnum) * 100
							)
						)

					pbar.value = 0
					setarrowcursor()
					redrawviews()
					ts_end = timeStamp()
					dtime = ((ts_end - ts_start)/1000.0)
					pushprompt ((dtime as string) + "sec")
					if failed != 0 do
						(
						skinops.selectvertices skinobj failedlist
						messagebox (failed as string + " Verts failed to flip\nIt could be your threshhold is too low\nTry increasing it a little bit.") title:"Mirror paste V2.0"

						registerredrawviewscallback drawfailed
						viewcancel.enabled = true
						viewcancel.checked = true
						showexpected = true
						)
					)
				else
					(
					messagebox ("Select some verts first!" title:"Dumbass")
					)
				)
			
			on viewcancel changed arg do
				(
				unregisterredrawviewscallback drawfailed
				viewcancel.enabled = false
				showexpected = true
				completeredraw()
				)
			)
		createdialog mirrorpaste 130 270
		)
	)
	
--***********************************************************************************************************************************************************************************

macroScript mirrorbonepaste_arranged category:"Skin Tools" buttontext:"Mirror Bone Paste Arranged"
	(
	local mirrorpaste
	on isvisible do
		(
		return (classof (modpanel.getcurrentobject()) == skin)
		)
	
	on execute do
		(
		rollout Mirrorpaste "Mirror Paste" width:130 height:270
			(
			local weights, bones, failed, failedlist, showexpected = false
			local expected = #()			
			local omesh
			
			function getoppositebone tmpskinobj source lident rident = 
				(
				local findobj
				sourcename = skinops.getbonename tmpskinobj source 1
				if (matchpattern sourcename pattern:("*" + lident + "*") ignorecase:false) then
					(
					--print "flipping to right"
					f = findstring sourcename lident
					findobj = replace sourcename f lident.count rident 
					)
				else
					(
					if (matchpattern sourcename pattern:("*" + rident + "*") ignorecase:false) then
						(
						--print "flipping to left"
						f = findstring sourcename rident
						findobj = replace sourcename f rident.count lident 
						)
					else
						(
						--print "not flipping"
						return source
						)
					)
				for i = 1 to (skinops.getnumberbones tmpskinobj) do
					(
					if (skinops.getbonename tmpskinobj i 1) == findobj do
						(
						return i
						)
					)
				return source
				)			
			
			function findmirrorvert obj &omesh vert axis tol cpoint = 
				(
				num = 1
				
				case cpoint of
					(
					3 : c = [0,0,0]
					2 : c = obj.pivot
					1 : c = obj.center
					)
				
				testvert = ((getvert omesh vert) * obj.objecttransform) - c
				
				case axis of
					(
					#X : testvert *= [-1,1,1]
					#Y : testvert *= [1,-1,1]
					#Z : testvert *= [1,1,-1]
					#XY : testvert *= [-1,-1,1]
					#XZ : testvert *= [-1,1,-1]
					#YZ : testvert *= [1,-1,-1]
					)
					
				for i = 1 to omesh.numverts do
					(
					v = ((getvert omesh i) * obj.objecttransform) - c

					if (length (v - testvert)) < tol do
						(
						return i
						)
					)
				return (testvert + c)
				)
			
			function drawfailed = 
				(
				gw.settransform (matrix3 1)

				for i in mirrorpaste.expected do
					(
					gw.marker i #plussign color:yellow
					)
				gw.enlargeupdaterect #whole
				gw.updatescreen()				
				)
	
			groupBox grp1 "World Axis" pos:[5,4] width:120 height:54
			radioButtons useaxis "" pos:[9,22] width:111 height:32 labels:#("X", "Y", "Z", "XY", "XZ", "YZ") columns:3
			groupBox grp2 "Bone Identifiers" pos:[5,62] width:120 height:57
			editText leftident "" pos:[41,80] width:80 height:1 text:"L"
			editText rightident "" pos:[41,99] width:80 height:1 text:"R"
			groupBox grp3 "Mirror Centre" pos:[5,124] width:120 height:57
			radioButtons centrepoint "" pos:[12,142] width:102 height:32 labels:#("Mesh", "Pivot", "World") columns:2
			spinner threshhold "Threshhold" pos:[14,186] width:102 height:16 range:[0.000001,10,0.001] scale:0.01
			button Mirrorverts "Mirror" pos:[5,206] width:120 height:20
			progressBar pbar "" pos:[5,229] width:120 height:10 color:(color 30 10 190)
			checkButton viewcancel "Cancel Display" pos:[5,243] width:120 height:20 highlightcolor:green
			label lbl1 "Left" pos:[11,82] width:32 height:15
			label lbl2 "Right" pos:[11,98] width:32 height:15
			
			on mirrorpaste close do
				(
				if showexpected do
					(
					unregisterredrawviewscallback drawfailed
					completeredraw()					
					)
				)
			
			on mirrorverts pressed do
				(
				omesh = $.mesh
				if showexpected do
					(
					unregisterredrawviewscallback drawfailed
					viewcancel.checked = false
					viewcancel.enabled = false
					showexpected = false					
					completeredraw()					
					)				
				
				failed = 0
				failedlist = #{}
				expected = #()
				
				case useaxis.state of
					(
					1 : axis = #X
					2 : axis = #Y
					3 : axis = #Z
					4 : axis = #XY
					5 : axis = #XZ
					6 : axis = #YZ
					)
				
				skinobj = modpanel.getcurrentobject()
				
				selverts = #()
				selvertsnum = 0
				for i = 1 to omesh.numverts do
					(
					if (skinops.isvertexselected skinobj i) == 1 do selverts[selvertsnum += 1] = i
					)
				
				if selvertsnum != 0 then
					(
					ts_start = timeStamp()
					with redraw off
						(
						setwaitcursor()
						for i = 1 to selvertsnum do
							(
							if classof (newv = findmirrorvert $ &omesh selverts[i] axis threshhold.value centrepoint.state) == integer then
								(
								format (selverts[i] as string + "," + newv as string)
								weights = #()
								bones = #()
--								numbones = skinops.getvertexweightcount skinobj selverts[i]
								numbones = skinops.getvertexweightcount skinobj newv

								for n = 1 to numbones do
									(
--									weights[n] = skinops.getvertexweight skinobj selverts[i] n
									weights[n] = skinops.getvertexweight skinobj newv n
--									boneid = (skinops.getvertexweightboneid skinobj selverts[i] n)
									boneid = (skinops.getvertexweightboneid skinobj newv n)
--									bones[n] = getoppositebone skinobj boneid leftident.text rightident.text
									bones[n] = getoppositebone skinobj boneid leftident.text rightident.text
									)
								disablesceneredraw()
--								skinops.replacevertexweights skinobj newv bones weights
								skinops.replacevertexweights skinobj selverts[i] bones weights
								enablesceneredraw()
								)
							else
								(
								failed += 1
								failedlist[selverts[i]] = true
								append expected newv
								)
							pbar.value = (i as float / selvertsnum) * 100
							)
						)

					pbar.value = 0
					setarrowcursor()
					redrawviews()
					ts_end = timeStamp()
					dtime = ((ts_end - ts_start)/1000.0)
					pushprompt ((dtime as string) + "sec")
					if failed != 0 do
						(
						skinops.selectvertices skinobj failedlist
						messagebox (failed as string + " Verts failed to flip\nIt could be your threshhold is too low\nTry increasing it a little bit.") title:"Mirror paste V2.0"

						registerredrawviewscallback drawfailed
						viewcancel.enabled = true
						viewcancel.checked = true
						showexpected = true
						)
					)
				else
					(
					messagebox ("Select some verts first!" title:"Dumbass")
					)
				)
			
			on viewcancel changed arg do
				(
				unregisterredrawviewscallback drawfailed
				viewcancel.enabled = false
				showexpected = true
				completeredraw()
				)
			)
		createdialog mirrorpaste 130 270
		)
	)
	
--***********************************************************************************************************************************************************************************

macroscript regrabskin category:"Skin Tools" buttontext:"Regrab Skin"
	(
	on isvisible do
		(
		return ((selection.count == 1) and (classof (modpanel.getcurrentobject()) == skin))
		)
	
	on execute do
		(
		function getvertweights skin vert = 
			(
			struct vertweight (index, weight)
			newvertweight = vertweight index:#() weight:#()
			for i = 1 to (skinops.getvertexweightcount skin vert) do
				(
				newvertweight.index[i] = skinops.getvertexweightboneid skin vert i
				newvertweight.weight[i] = skinops.getvertexweight skin vert i
				)
			return newvertweight
			)
			
		theweights = #()
		skinobj = modpanel.getcurrentobject()
		omesh = $.mesh
		disablesceneredraw()
		try
			(
			skinobj.always_deform = false
			for i = 1 to omesh.numverts do
				(
				theweights[i] = getvertweights skinobj i
				)
			
			skinops.resetallbones skinobj
			
			for i = 1 to omesh.numverts do
				(
				skinops.replacevertexweights skinobj i theweights[i].index theweights[i].weight
				)
			skinobj.always_deform = true
			omesh = undefined
			gc()
			enablesceneredraw()
			)
		catch
			(
			messagebox "error!"
			omesh = undefined
			gc()			
			enablesceneredraw()
			)
		)
	)--end of macro

--***********************************************************************************************************************************************************************************

macroscript Reverse_crossections category:"Skin Tools" buttontext:"Reverse crosssection"
	(
	on isvisible do
		(
		return (classof (modpanel.getcurrentobject()) == skin)
		)
	
	on execute do
		(
		local myskin = modpanel.getcurrentobject()
		
		local rad1 = #()
		local rad2 = #()
		local upos = #()
		
		disablesceneredraw()
		try
			(
			--*	grab all info	*
			local selbone = (skinops.getselectedbone myskin)
			local numsections = (skinops.getnumbercrosssections myskin selbone)
			for i = 1 to numsections do
				(
				rad1[i] = skinops.getinnerradius myskin selbone i
				rad2[i] = skinops.getouterradius myskin selbone i
				upos[i] = 1.0 - (skinops.getcrosssectionU myskin selbone i)
				)
			
			--*	put all back in reverse order	*
			
			for i = 1 to numsections do
				(
				skinops.setinnerradius myskin selbone i rad1[((numsections + 1) - i)]
				skinops.setouterradius myskin selbone i rad2[((numsections + 1) - i)]
				skinops.setcrosssectionU myskin selbone i upos[((numsections + 1) - i)]
				)			
			enablesceneredraw()
			max views redraw
			)
		catch
			(
			enablesceneredraw()
			)
		)
	)--*	end of script

--***********************************************************************************************************************************************************************************

macroscript skinweightinfo category:"Skin Tools" buttontext:"Skin Weight Info"
	(
	local skinweightsroll

	on isvisible do
		(
		return ((selection.count == 1) and (classof (modpanel.getcurrentobject()) == skin))
		)
	
	on execute do
		(
		global vpos = [10,10,10]
		global dodraw = false
		rollout skinweightsroll "Options" 
			(
			function normalizeX num = 
				(
				dv = 0.0
				for i = 1 to num.count do
					(
					dv += num[i]
					)
				
				for i = 1 to num.count do
					(
					num[i] /= dv
					)
				return num
				)			
				
			function viewportcallback = 
				(
				if dodraw do
					(
					gw.settransform(matrix3 1)
					gw.marker vpos #bigbox color:yellow
					gw.enlargeupdaterect #whole
					gw.updatescreen()
					)
				)

			function regviewportcallback = 
				(
				try (viewportcallback()) catch (unregisterredrawviewscallback regviewportcallback)
				)


			function isnormalized &sknobj index = 
				(
				w = 0.0
				for i = 1 to (skinops.getvertexweightcount sknobj index) do
					(
					w += skinops.getvertexweight sknobj index i
					)
				if w == 1.0 do return true
				return false
				)				
			
			local selverts = #()
			local currentvert = 0
			local sknobj = undefined
			local obj = undefined
			local omesh = undefined
			
			button downvert "<<" pos:[6,7] width:20 height:20 enabled:false
			label verttext "Vertex : 0" pos:[43,9] width:90 height:16
			button upvert ">>" pos:[133,7] width:20 height:20 enabled:false
			button getselection "Get Selection" pos:[6,30] width:147 height:20
			listBox weightslist "" pos:[6,55] width:147 height:9

			label totalw "Total Weight : 0.0" width:147 pos:[6,182]
			button doexclude "Exclude" pos:[6,202] width:147 height:20
			
			groupBox grp11 "Rule select" pos:[7,232] width:146 height:112
			button doselect "Select" pos:[15,322] width:130 height:15
			dropDownList ruletype "Rule" pos:[15,253] width:130 height:40 items:#("Unweighted" , "< than", "> than", "= to", "< than or = to",  "> than or = to", "Non-normalized")
			spinner rulecount "Vert count" pos:[18,300] width:124 height:16 range:[0,99999,0] type:#integer scale:1 fieldwidth:40

			on doselect pressed do
				(
				v = #()

				for i = 1 to omesh.numverts do
					(
					case ruletype.selection of
						(
						1: (if skinops.getvertexweightcount sknobj i == 0 do append v i)
						2: (if skinops.getvertexweightcount sknobj i < rulecount.value do append v i)
						3: (if skinops.getvertexweightcount sknobj i > rulecount.value do append v i)
						4: (if skinops.getvertexweightcount sknobj i == rulecount.value do append v i)
						5: (if skinops.getvertexweightcount sknobj i <= rulecount.value do append v i)
						6: (if skinops.getvertexweightcount sknobj i >= rulecount.value do append v i)
						7: (if (isnormalized &sknobj i) == false do append v i)
						)
					)

				skinops.selectvertices sknobj v				
				pushprompt ("Selected " + v.count as string + " verts")
				dodraw = false
				getselection.pressed()
				
				)
			
			on skinweightsroll open do
				(
				obj = $
				sknobj = modpanel.getcurrentobject()
				omesh = $.mesh
				registerredrawviewscallback regviewportcallback
				)
			
			on skinweightsroll close do
				(
				omesh = undefined
				gc()
				unregisterredrawviewscallback regviewportcallback
				)
			
			on weightslist doubleclicked val do
				(
				skinops.selectbone sknobj (skinops.getvertexweightboneid sknobj selverts[currentvert] val)
				)
			
			on doexclude pressed do
				(
				if (selverts.count >= 1) do
					(
					bones = #()
					weights = #()
					thecount = 0
					weighttot = 0.0
					numbones  = (skinops.getvertexweightcount sknobj selverts[currentvert])
					
					for i = 1 to numbones do
						(
						bones[thecount += 1] = skinops.getvertexweightboneid sknobj selverts[currentvert] i
						weights[thecount] = skinops.getvertexweight sknobj selverts[currentvert] i
						)
					
					deleteitem bones weightslist.selection
					deleteitem weights weightslist.selection
					
					for i = 1 to (thecount - 1) do
						(
						weighttot += weights[i]
						)

					for i = 1 to (thecount - 1) do
						(
						weights[i] /= weighttot
						)
					skinops.replacevertexweights sknobj selverts[currentvert] bones weights
					
					items = #()
					for n = 1 to (skinops.getvertexweightcount sknobj selverts[currentvert]) do
						(
						boneindex = (skinops.getvertexweightboneid sknobj selverts[currentvert] n)
						str = (skinops.getbonename sknobj boneindex n)
						str += "   "
						str += (skinops.getvertexweight sknobj selverts[currentvert] n) as string
						items[n] = str
						)
					weightslist.items = items
					)
				dodraw = false
				)
			
			on getselection pressed do
				(
				if true do
					(
					sknobj = modpanel.getcurrentobject()
					selverts = #()
					selvertscount = 0
					for i = 1 to omesh.numverts do
						(
						if (skinops.isvertexselected sknobj i) == 1 do
							(
							selverts[selvertscount += 1] = i
							)
						)
					if selverts.count != 0 then
						(	
						items = #()
						bones = skinops.getvertexweightcount sknobj selverts[1]
						tweight = 0.0
						for n = 1 to bones do
							(
							boneindex = (skinops.getvertexweightboneid sknobj selverts[1] n)
							str = (skinops.getbonename sknobj boneindex n)
							str += "   "
							w = (skinops.getvertexweight sknobj selverts[1] n)
							tweight += w
							str += w as string
							items[n] = str
							)
						weightslist.items = items
						totalw.text = "Total Weight : " + tweight as string
						verttext.text = ("Vertex : 1 of " + selvertscount as string)
						vpos = (getvert omesh selverts[1]) * obj.objecttransform
	
						upvert.enabled = true
						downvert.enabled = true
						currentvert = 1
						dodraw = true
						)
					else
						(
						upvert.enabled = false
						downvert.enabled = false
						weightslist.items = #()
						totalw.text = "Total Weight : 0.0"
						verttext.text = "Vertex : 0 of 0"
						dodraw = false
						)
					)
				nodeinvalrect obj
				redrawviews()
				)


			on downvert pressed do
				(
				currentvert -= 1
				
				if (currentvert >= 1)  then
					(
					vpos = (getvert obj.mesh selverts[currentvert]) * obj.objecttransform
					items = #()
					bones = skinops.getvertexweightcount sknobj selverts[currentvert]
					tweight = 0.0
					for n = 1 to bones do
						(
						boneindex = (skinops.getvertexweightboneid sknobj selverts[currentvert] n)
						str = (skinops.getbonename sknobj boneindex n)
						str += "   "
						w = (skinops.getvertexweight sknobj selverts[currentvert] n)
						str += w as string
						tweight += w
						items[n] = str
						)
					weightslist.items = items
					totalw.text = "Total Weight : " + tweight as string
					verttext.text = ("Vertex : " + currentvert as string + " of " + selverts.count as string)
					)
				else
					(
					currentvert = 1
					)
				nodeinvalrect obj
				dodraw = true
				redrawviews()
				)

			on upvert pressed do
				(
				currentvert += 1
				
				if (currentvert <= selverts.count) then
					(
					vpos = (getvert omesh selverts[currentvert]) * obj.objecttransform
					items = #()
					bones = skinops.getvertexweightcount sknobj selverts[currentvert]
					tweight = 0.0
					for n = 1 to bones do
						(
						boneindex = (skinops.getvertexweightboneid sknobj selverts[currentvert] n)
						str = (skinops.getbonename sknobj boneindex n)
						str += "   "
						w = (skinops.getvertexweight sknobj selverts[currentvert] n)
						tweight += w
						str += w as string
						items[n] = str
						)
					weightslist.items = items
					totalw.text = "Total Weight : " + tweight as string
					verttext.text = ("Vertex : " + currentvert as string + " of " + selverts.count as string)
					)
				else
					(
					currentvert = selverts.count
					)
				nodeinvalrect obj
				dodraw = true
				redrawviews()
				)				
			)
		createdialog skinweightsroll 160 351
		)
	)--end of macro

--***********************************************************************************************************************************************************************************

macroscript skingradient category:"Skin Tools" buttontext:"Skin Gradient"
	(
	local skingradientroll	
	on isvisible do
		(
		return (classof (modpanel.getcurrentobject()) == skin)
		)
	
	on execute do
		(
		rollout skingradientroll "Skin Gradient"
			(
			tool skinvertgradient numpoints:3  
				(
				local startpoint = undefined
				local endpoint = undefined
				local col1, col2, diff, skn,omesh
				
				on start do
					(
					skn = modpanel.getcurrentobject()
					omesh = $.mesh
					col1 = skingradientroll.uc1.value
					col2 = skingradientroll.uc2.value
					diff = col2 - col1
					gw.settransform (matrix3 1)
					)
				
				on mousemove val do
					(
					if val == 3 do
						(
						forcecompleteredraw()
						gw.settransform (matrix3 1)
						gw.setcolor #line green
						gw.polyline #(startpoint, worldpoint) false
						gw.marker startpoint #hollowbox color:yellow
						gw.marker worldpoint #hollowbox color:yellow
						gw.enlargeupdaterect #whole
						gw.updatescreen()						
						)
					)
				
				on mousepoint val do
					(
					if val == 1 do 
						(
						startpoint = worldpoint
						)
					if val == 3 do 
						(
						disablesceneredraw()
						try
							(
							-- grab endpoint and setup inverse map matrix
							endpoint = worldpoint
							vtm = (viewport.gettm())
							invvtm = inverse vtm
							d = dot startpoint invvtm.row3
							newstart = startpoint + (d * -invvtm.row3)
				
							d = dot endpoint invvtm.row3
							newend = endpoint + (d * -invvtm.row3)						
							
							x = normalize (newend - newstart)
							y = cross x invvtm.row3
							z = cross x y
							maptm = (matrix3 x y z newstart)
							invmaptm = inverse maptm
							range = length (newend - newstart)
							
							-- get all selected verts
							
							selverts = #()
							for i = 1 to omesh.numverts do
								(
								if skinops.isvertexselected skn i == 1 do append selverts i
								)
							selvertscount = selverts.count
							
							-- get selected bone
							
							selbone = skinops.getselectedbone skn
							
							-- tranform point into gradient space
							-- measure vert distance in gradient space and assign weight
							for i = 1 to selvertscount do
								(
								objvert = ((getvert omesh selverts[i]) * $.objecttransform) * invmaptm
			
								case skingradientroll.gtype.state of
									(
									1 : calcval = col1 + (diff  * (objvert.x / range))
									2 : calcval = col1 + (diff  * (length [objvert.x, objvert.y,0] / range))
									3 : calcval = col1 + (diff  * (sin ((objvert.x / range) * 180)))
									4 : calcval = col1 + (diff  * (sin ((objvert.x / range) * 360)))
									)
								
								skinops.setvertexweights skn selverts[i] selbone calcval
								)
							enablesceneredraw()
							)
						catch (enablesceneredraw(); print "failed!")
						)
					)
				)
		
			checkbutton startg "Gradient" pos:[9,8] width:130 height:16 highlightcolor:green
			spinner uc1 "Start value" range:[0,1,1.0] pos:[13,28] width:112 height:16 fieldwidth:30
			spinner uc2 "End value" range:[0,1,0.0] pos:[16,48] width:109 height:16 fieldwidth:30
			button doreset "R" pos:[127,28] height:16 width:10 tooltip:"Reset"
			button doswap "S" pos:[127,48] height:16 width:10 tooltip:"Swap"
			group "Type"
				(
				radioButtons gtype "" labels:#("Linear", "Radial", "Loop", "Loop2") columns:2
				)
			
			on startg changed state do
				(
				if selection.count == 1 then
					(
					starttool skinvertgradient
					startg.checked = false
					)
				else
					(
					messagebox "Select an object!"
					)
				)
			
			on doreset pressed do
				(
				uc1.value = 1.0
				uc2.value = 0.0
				)
			
			on doswap pressed do	
				(
				swap uc1.value uc2.value
				)
			)
		
		createdialog skingradientroll 148 130 style:#(#style_titlebar, #style_minimizebox, #style_sysmenu)	
		)
	)

--***********************************************************************************************************************************************************************************	

macroscript moveboneweights category:"Skin Tools" buttontext:"Move/Swap Bone Weights"
	(
	local prog

	on isvisible do
		(
		return (classof (modpanel.getcurrentobject()) == skin)
		)
	
	on execute do
		(
		rollout prog "Move/Swap Bone Weights"
			(
			group ""
				(
				spinner bone1 "BONE1" range:[1,99,1] type:#integer fieldwidth:30 across:2 align:#left offset:[-5,-5]
				spinner bone2 "-->BONE2" range:[1,99,1] type:#integer fieldwidth:30 align:#left offset:[-10,-5]
				radiobuttons moveorswap "" labels:#("Move", "Swap") columns:2 across:2 align:#left offset:[0,0]
				button moveweights "GO!" height:15 width:50 align:#left offset:[30,0]
				progressbar progbar color:(color 0 255 0) height:7 width:180 align:#center offset:[0,0]
				)
			group ""
				(
				button dumpbonename "Dump Bone Name" height:15 width:180 align:#center offset:[0,-5]
				)


			on moveweights pressed do
				(
				skinobject = modpanel.getcurrentobject()
				omesh = $.mesh
				numbone = skinOps.GetNumberBones skinobject
				if (1 == moveorswap.state) Do str_mos = "Move"
				if (2 == moveorswap.state) Do str_mos = "Swap"
				if ( bone1.value > numbone or bone2.value > numbone) Do
					(
					messagebox ("Error:Bone ID is too Large.\n(number of bones = " + (numbone as string) + ")")
					return 1
					)
				if ( bone1.value == bone2.value) Do
					(
					messagebox ("Error: BONE1 and BONE2 are same bone.")
					return 1
					)
				bonename1 = skinOps.GetBoneName skinobject bone1.value 1
				bonename2 = skinOps.GetBoneName skinobject bone2.value 1
				if not(querybox ("Function : " + str_mos + "\nBONE1 : (" + (bone1.value as string) + ") " + bonename1 +"\nBONE2 : (" + (bone2.value as string) + ") " + bonename2) title:"Confirmation") do
					(
					return 1
					)

				counter = 0
				disablesceneredraw()
				try
					(
					for i = 1 to omesh.numverts do --Move/Swap Bone Weights Loop
						(
						v = getvert omesh i
						flg1 = 0
						flg2 = 0
						weight1 = 0.0
						weight2 = 0.0
						for n = 1 to (skinops.getvertexweightcount skinobject i) do
							(
							id = (skinops.getvertexweightboneid skinobject i n) 
							if (id == bone1.value) do
								(
								flg1 = 1
								weight1 = (skinops.getvertexweight skinobject i n)
								)
							if (id == bone2.value) do
								(
								flg2 = 1
								weight2 = (skinops.getvertexweight skinobject i n)
								)
							)
						if (1 == moveorswap.state) Do
							(
							if (0 != flg1) do
								(
								skinOps.SetVertexWeights skinobject i bone1.value 0.0
								skinOps.SetVertexWeights skinobject i bone2.value (weight1 + weight2)
								counter += 1
								)
							)
						if (2 == moveorswap.state) Do
							(
							if (0 != flg1 or 0 != flg2) do
								(
								skinOps.SetVertexWeights skinobject i bone1.value weight2
								skinOps.SetVertexWeights skinobject i bone2.value weight1
								counter += 1
								)
							)
						progbar.value = (i as float / omesh.numverts) * 100
						)--End of Move/Swap Bone Weights Loop

					for i = 1 to omesh.numverts do --clearzeroweights Loop
						(
						bones = skinops.getvertexweightcount skinobject i
						id = #()
						weight = #()
						idcount = 0
						norm = 0
						for n = 1 to bones do
							(
							if (w = skinops.getvertexweight skinobject i n) > 0.0001 do
								(
								boneindex = skinops.getvertexweightboneid skinobject i n
								id[idcount += 1] = boneindex
								weight[idcount] = w
								norm += w
								)
							)
						
						for n = 1 to idcount do
							(
							weight[n] /= norm
							)
						
						skinops.replacevertexweights skinobject i id weight
						)
					enablesceneredraw()
					)--End of clearzeroweights Loop
				
				catch
					(
					enablesceneredraw()
					pushprompt ("Error in clearing zero weights.")
					messagebox ("Error in clearing zero weights.")
					)

				if (1 == moveorswap.state) Do str_mos = "Moved "
				if (2 == moveorswap.state) Do str_mos = "Swapped "
				pushprompt (str_mos + counter as string + " vertex weights")
				messagebox (str_mos + counter as string + " vertex weights") title:"Done"
				) -- End of moveweights

			on dumpbonename pressed do
				(
				skinobject = modpanel.getcurrentobject()
				numbone = skinOps.GetNumberBones skinobject
				clearlistener()
				for i = 1 to numbone do
					(
					format "%,%\n" i (skinOps.GetBoneName skinobject i 1)
					)
				pushprompt ("Dumped to MAXScript Listener.")
				messagebox ("Dumped to MAXScript Listener.") title:"Done"
				) -- End of dumpbonename
			)--end of rollout
		createdialog prog 200 120 
		)-- end of on execute
	)--end of macro
	
--***********************************************************************************************************************************************************************************	
macroscript memselverts category:"Skin Tools" buttontext:"Memorise Selected Vertices"
	(
	local memselvertsroll

	on isvisible do
		(
		return ((selection.count == 1) and (classof (modpanel.getcurrentobject()) == skin))
		)
	
	on execute do
		(
		global memselvertsroll
		global vpos = [10,10,10]
		rollout skinweightsroll "MemSelVerts" 
			(
			local v = #()
			local sknobj = undefined
			local obj = undefined
			local omesh = undefined
			
			group "Mem#1"
				(
				label  lab1 "Vets : ---" width:120 height:12
				button mem1 "Mem" across: 4 width:40 height:15
				button set1 "Set" offset:[10,0] width:40 height:15
				button add1 "+" offset:[15,0] width:20 height:15
				button sub1 "-" offset:[10,0] width:20 height:15
				)
			group "Mem#2"
				(
				label  lab2 "Vets : ---" width:120 height:12
				button mem2 "Mem" across: 4 width:40 height:15
				button set2 "Set" offset:[10,0] width:40 height:15
				button add2 "+" offset:[15,0] width:20 height:15
				button sub2 "-" offset:[10,0] width:20 height:15
				)
			group "Mem#3"
				(
				label  lab3 "Vets : ---" width:120 height:12
				button mem3 "Mem" across: 4 width:40 height:15
				button set3 "Set" offset:[10,0] width:40 height:15
				button add3 "+" offset:[15,0] width:20 height:15
				button sub3 "-" offset:[10,0] width:20 height:15
				)
			group "Mem#4"
				(
				label  lab4 "Vets : ---" width:120 height:12
				button mem4 "Mem" across: 4 width:40 height:15
				button set4 "Set" offset:[10,0] width:40 height:15
				button add4 "+" offset:[15,0] width:20 height:15
				button sub4 "-" offset:[10,0] width:20 height:15
				)
			group "Mem#5"
				(
				label  lab5 "Vets : ---" width:120 height:12
				button mem5 "Mem" across: 4 width:40 height:15
				button set5 "Set" offset:[10,0] width:40 height:15
				button add5 "+" offset:[15,0] width:20 height:15
				button sub5 "-" offset:[10,0] width:20 height:15
				)
			button save_vset "Save SelVerts" width:100 height:15
			button load_vset "Load SelVerts" width:100 height:15
			progressbar pbar offset:[0,5] width:130 height:10 align:#center
			
			
			-----on mem pressed-----
			on mem1 pressed do
				(
				pbar.value = 0.0
				memid = 1
				v[memid] = #()
				for i = 1 to omesh.numverts do
					(
					if (skinops.isvertexselected sknobj i) == 1 do append v[memid] i
					pbar.value = (i as float / omesh.numverts) * 100
					)
				pushprompt ("memorized " + v[memid].count as string + " verts to Mem#" + memid as string +".")
				lab1.text = ("Verts : " + v[memid].count as string + " verts")
				)
			
			on mem2 pressed do
				(
				pbar.value = 0.0
				memid = 2
				v[memid] = #()
				for i = 1 to omesh.numverts do
					(
					if (skinops.isvertexselected sknobj i) == 1 do append v[memid] i
					pbar.value = (i as float / omesh.numverts) * 100
					)
				pushprompt ("memorized " + v[memid].count as string + " verts to Mem#" + memid as string +".")
				lab2.text = ("Verts : " + v[memid].count as string + " verts")
				)
			
			on mem3 pressed do
				(
				pbar.value = 0.0
				memid = 3
				v[memid] = #()
				for i = 1 to omesh.numverts do
					(
					if (skinops.isvertexselected sknobj i) == 1 do append v[memid] i
					pbar.value = (i as float / omesh.numverts) * 100
					)
				pushprompt ("memorized " + v[memid].count as string + " verts to Mem#" + memid as string +".")
				lab3.text = ("Verts : " + v[memid].count as string + " verts")
				)
			
			on mem4 pressed do
				(
				pbar.value = 0.0
				memid = 4
				v[memid] = #()
				for i = 1 to omesh.numverts do
					(
					if (skinops.isvertexselected sknobj i) == 1 do append v[memid] i
					pbar.value = (i as float / omesh.numverts) * 100
					)
				pushprompt ("memorized " + v[memid].count as string + " verts to Mem#" + memid as string +".")
				lab4.text = ("Verts : " + v[memid].count as string + " verts")
				)
			
			on mem5 pressed do
				(
				pbar.value = 0.0
				memid = 5
				v[memid] = #()
				for i = 1 to omesh.numverts do
					(
					if (skinops.isvertexselected sknobj i) == 1 do append v[memid] i
					pbar.value = (i as float / omesh.numverts) * 100
					)
				pushprompt ("memorized " + v[memid].count as string + " verts to Mem#" + memid as string +".")
				lab5.text = ("Verts : " + v[memid].count as string + " verts")
				)
			
			-----set pressed-----
			on set1 pressed do
				(
				pbar.value = 0.0
				memid = 1
				if v[memid].count != 0 then
					(
					skinops.selectvertices sknobj v[memid]
					)
				pbar.value = 100.0
				pushprompt ("set " + v[memid].count as string + " verts from Mem#" + memid as string +" to obj.")
				)
			
			on set2 pressed do
				(
				pbar.value = 0.0
				memid = 2
				if v[memid].count != 0 then
					(
					skinops.selectvertices sknobj v[memid]
					)
				pbar.value = 100.0
				pushprompt ("set " + v[memid].count as string + " verts from Mem#" + memid as string +" to obj.")
				)
			
			on set3 pressed do
				(
				pbar.value = 0.0
				memid = 3
				if v[memid].count != 0 then
					(
					skinops.selectvertices sknobj v[memid]
					)
				pbar.value = 100.0
				pushprompt ("set " + v[memid].count as string + " verts from Mem#" + memid as string +" to obj.")
				)
			
			on set4 pressed do
				(
				pbar.value = 0.0
				memid = 4
				if v[memid].count != 0 then
					(
					skinops.selectvertices sknobj v[memid]
					)
				pbar.value = 100.0
				pushprompt ("set " + v[memid].count as string + " verts from Mem#" + memid as string +" to obj.")
				)
			
			on set5 pressed do
				(
				pbar.value = 0.0
				memid = 5
				if v[memid].count != 0 then
					(
					skinops.selectvertices sknobj v[memid]
					)
				pbar.value = 100.0
				pushprompt ("set " + v[memid].count as string + " verts from Mem#" + memid as string +" to obj.")
				)
			
			-----on add pressed-----
			on add1 pressed do
				(
				pbar.value = 0.0
				memid = 1
				if v[memid].count != 0 then
					(
					vtmp = #()
					for i = 1 to omesh.numverts do
						(
						if (skinops.isvertexselected sknobj i) == 1 do append vtmp i
						pbar.value = (i as float / omesh.numverts) * 100
						)
					counter = vtmp.count
					join vtmp v[memid]
					counter = vtmp.count - counter
					skinops.selectvertices sknobj vtmp
					)
				pushprompt ("added " + counter as string + " verts to selected verts set")
				)
			
			on add2 pressed do
				(
				pbar.value = 0.0
				memid = 2
				if v[memid].count != 0 then
					(
					vtmp = #()
					for i = 1 to omesh.numverts do
						(
						if (skinops.isvertexselected sknobj i) == 1 do append vtmp i
						pbar.value = (i as float / omesh.numverts) * 100
						)
					counter = vtmp.count
					join vtmp v[memid]
					counter = vtmp.count - counter
					skinops.selectvertices sknobj vtmp
					)
				pushprompt ("added " + counter as string + " verts to selected verts set")
				)
			
			on add3 pressed do
				(
				pbar.value = 0.0
				memid = 3
				if v[memid].count != 0 then
					(
					vtmp = #()
					for i = 1 to omesh.numverts do
						(
						if (skinops.isvertexselected sknobj i) == 1 do append vtmp i
						pbar.value = (i as float / omesh.numverts) * 100
						)
					counter = vtmp.count
					join vtmp v[memid]
					counter = vtmp.count - counter
					skinops.selectvertices sknobj vtmp
					)
				pushprompt ("added " + counter as string + " verts to selected verts set")
				)
			
			on add4 pressed do
				(
				pbar.value = 0.0
				memid = 4
				if v[memid].count != 0 then
					(
					vtmp = #()
					for i = 1 to omesh.numverts do
						(
						if (skinops.isvertexselected sknobj i) == 1 do append vtmp i
						pbar.value = (i as float / omesh.numverts) * 100
						)
					counter = vtmp.count
					join vtmp v[memid]
					counter = vtmp.count - counter
					skinops.selectvertices sknobj vtmp
					)
				pushprompt ("added " + counter as string + " verts to selected verts set")
				)
			
			on add5 pressed do
				(
				pbar.value = 0.0
				memid = 5
				if v[memid].count != 0 then
					(
					vtmp = #()
					for i = 1 to omesh.numverts do
						(
						if (skinops.isvertexselected sknobj i) == 1 do append vtmp i
						pbar.value = (i as float / omesh.numverts) * 100
						)
					counter = vtmp.count
					join vtmp v[memid]
					counter = vtmp.count - counter
					skinops.selectvertices sknobj vtmp
					)
				pushprompt ("added " + counter as string + " verts to selected verts set")
				)
			
			-----on sub pressed-----
			on sub1 pressed do
				(
				pbar.value = 0.0
				memid = 1
				if v[memid].count != 0 then
					(
					vtmp = #()
					counter = 0
					for i = 1 to omesh.numverts do
						(
						if (skinops.isvertexselected sknobj i) == 1 then
							(
							flg = 0
							for j = 1 to v[memid].count do
								(
								if i == v[memid][j] then
									(
									flg = 1
									counter += 1
									break
									)
								)
							if flg == 0 do append vtmp i
							)
						pbar.value = (i as float / omesh.numverts) * 100
						)
					skinops.selectvertices sknobj vtmp
					)
				pushprompt ("subtracted " + counter as string + " verts from selected verts set")
				)
			
			on sub2 pressed do
				(
				pbar.value = 0.0
				memid = 2
				if v[memid].count != 0 then
					(
					vtmp = #()
					counter = 0
					for i = 1 to omesh.numverts do
						(
						if (skinops.isvertexselected sknobj i) == 1 then
							(
							flg = 0
							for j = 1 to v[memid].count do
								(
								if i == v[memid][j] then
									(
									flg = 1
									counter += 1
									break
									)
								)
							if flg == 0 do append vtmp i
							)
						pbar.value = (i as float / omesh.numverts) * 100
						)
					skinops.selectvertices sknobj vtmp
					)
				pushprompt ("subtracted " + counter as string + " verts from selected verts set")
				)
			
			on sub3 pressed do
				(
				pbar.value = 0.0
				memid = 3
				if v[memid].count != 0 then
					(
					vtmp = #()
					counter = 0
					for i = 1 to omesh.numverts do
						(
						if (skinops.isvertexselected sknobj i) == 1 then
							(
							flg = 0
							for j = 1 to v[memid].count do
								(
								if i == v[memid][j] then
									(
									flg = 1
									counter += 1
									break
									)
								)
							if flg == 0 do append vtmp i
							)
						pbar.value = (i as float / omesh.numverts) * 100
						)
					skinops.selectvertices sknobj vtmp
					)
				pushprompt ("subtracted " + counter as string + " verts from selected verts set")
				)
			
			on sub4 pressed do
				(
				pbar.value = 0.0
				memid = 4
				if v[memid].count != 0 then
					(
					vtmp = #()
					counter = 0
					for i = 1 to omesh.numverts do
						(
						if (skinops.isvertexselected sknobj i) == 1 then
							(
							flg = 0
							for j = 1 to v[memid].count do
								(
								if i == v[memid][j] then
									(
									flg = 1
									counter += 1
									break
									)
								)
							if flg == 0 do append vtmp i
							)
						pbar.value = (i as float / omesh.numverts) * 100
						)
					skinops.selectvertices sknobj vtmp
					)
				pushprompt ("subtracted " + counter as string + " verts from selected verts set")
				)
			
			on sub5 pressed do
				(
				pbar.value = 0.0
				memid = 5
				if v[memid].count != 0 then
					(
					vtmp = #()
					counter = 0
					for i = 1 to omesh.numverts do
						(
						if (skinops.isvertexselected sknobj i) == 1 then
							(
							flg = 0
							for j = 1 to v[memid].count do
								(
								if i == v[memid][j] then
									(
									flg = 1
									counter += 1
									break
									)
								)
							if flg == 0 do append vtmp i
							)
						pbar.value = (i as float / omesh.numverts) * 100
						)
					skinops.selectvertices sknobj vtmp
					)
				pushprompt ("subtracted " + counter as string + " verts from selected verts set")
				)
			
			-----on save_vset pressed-----
			on save_vset pressed do
				(
				vtmp = #()
				for i = 1 to omesh.numverts do
					(
					if (skinops.isvertexselected sknobj i) == 1 do append vtmp i
					)
				pbar.value = 0.0
				if vtmp.count != 0 then
					(
					outname = getSaveFileName caption:"Save Selected Virtices Set" types:"Vertices Set (*.vset)|*.vset"
					if outname != undefined then
						(
						format "\n"
						clearlistener()
						format "<snoopstart file=%>\n" outname
						format "c 4 VSET i 1 %\n" vtmp.count
						format "i %\n" vtmp.count
						for i = 1 to vtmp.count do
							(
							format "%" vtmp[i]
							if 0 == (mod i 10) then format "\n"
							else format " "
							pbar.value = (i as float / vtmp.count) * 100
							)
						format "\n"
						format "</snoopend>\n"
						format "//"             --Don't remove this, it solve some win98 user problem
						pushprompt ("Saveed " + vtmp.count as string + " verts as " + outname as string + ".")
						)  -- if outname
					)  -- if vtmp.coun
				else
					(
					pushprompt ("No selected vertices.")
					messagebox ("No selected vertices.")
					)  -- else vtmp.count
				)
			
			-----on load_vset pressed-----
			on load_vset pressed do
				(
				inname = getopenfilename caption:"Open Virtices Set" filename:"*.vset;*.xml" types:"Virtices Set (*.vset)|*.vset|Virtices Set(text) (*.xml)|*.xml"
				if inname != undefined then
					(
					file_ext = getFilenameType(inname)
					if(".vset" == file_ext) then
						(
						infile = fopen inname "rb"
						vset_head = ReadLong infile
						if vset_head == 0x54455356    then  -- "VSET" = '0x54455356'
							(
							vtmp = #()
							num_verts = ReadLong infile
							pbar.value = 0.0
							for i = 1 to num_verts do
								(
								append vtmp (ReadLong infile)
								pbar.value = (i as float / num_verts) * 100
								)  --for i
							fclose infile
							skinops.selectvertices sknobj vtmp
							)  --if gwt_head
						else
							(
							fclose infile
							escapeenable = true
							messagebox "Not right file type!"
							destroydialog prog
							)  --if vset_head
						)  -- if .vset 
					else
						(
						infile = openfile inname
						v = #()
						while eof infile == False do
							(
							vi = (readline infile) as integer
							if vi > 0 then
								(
								append v vi
								)
							)
						verttext.text = ("MemVerts : " + v.count as string)
						pushprompt ("Loaded " + v.count as string + " verts.")
						messagebox ("Loaded " + v.count as string + " verts.")
						)  -- else .vset
					)  -- if inname
				)  -- on load_vset
			
			on skinweightsroll open do
				(
				obj = $
				sknobj = modpanel.getcurrentobject()
				omesh = $.mesh
				v = #()
				for i = 1 to 5 do v[i] = #()
				)
			
			on skinweightsroll close do
				(
				omesh = undefined
				gc()
				)
			)
		createdialog skinweightsroll 145 370 style:#(#style_titlebar, #style_minimizebox, #style_sysmenu)
		)
	)--end of macro

--***********************************************************************************************************************************************************************************	
